package com.sharix.sportsmanfriend;

import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;

public abstract class BaseFragmentClass extends Fragment {

    private Bundle savedState;
    private boolean saved;
    private static final String _FRAGMENT_STATE = "FRAGMENT_STATE";

    @Override
    public void onSaveInstanceState(@NonNull Bundle state) {
        if (getView() == null) {
            state.putBundle(_FRAGMENT_STATE, savedState);
        } else {
            Bundle bundle = saved ? savedState : getStateToSave();

            state.putBundle(_FRAGMENT_STATE, bundle);
        }

        saved = false;

        super.onSaveInstanceState(state);
    }

    @Override
    public void onCreate(Bundle state) {
        super.onCreate(state);
        if (state != null) {
            savedState = state.getBundle(_FRAGMENT_STATE);
        }
    }

    // срабатывает когда фрагмент закрывается
    @Override
    public void onDestroyView() {
        savedState = getStateToSave();
        saved = true;

        super.onDestroyView();
    }

    // возвращает сохраненные данные
    protected Bundle getSavedState() {
        return savedState;
    }

    // проверяет есть ли сохраненные данные, если да, то восстанавлиавает, если нет вохвращает false
    protected abstract boolean hasSavedState();

    // здесь нужно записать данные, которые нужно сохранить в случае закрытия фрагмента
    protected abstract Bundle getStateToSave();
}