package com.sharix.sportsmanfriend;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;

import java.io.IOException;
import java.io.InputStream;

public class PhotoHelperClass {

    // Получаем Bitmap из URI-адреса
    public static Bitmap getBitmapFromUri(Uri uri, Context context) {
        try {
            InputStream inputStream = context.getContentResolver().openInputStream(uri);
            Bitmap bitmap = BitmapFactory.decodeStream(inputStream);
            inputStream.close();
            return bitmap;
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }

    // создание квдартной фотографии
    public static Bitmap cropBitmapToSquare(Bitmap bitmap, Context context) {
        int width = bitmap.getWidth();
        int height = bitmap.getHeight();
        int size = Math.min(width, height);
        int x = (width - size) / 2;
        int y = (height - size) / 2;

        Bitmap croppedBitmap = Bitmap.createBitmap(bitmap, x, y, size, size);

        return Bitmap.createScaledBitmap(croppedBitmap, dpToPx(100, context), dpToPx(100,context), false);
    }

    // конвертация dp в пиксели
    public static int dpToPx(int dp, Context context) {
        float density = context.getResources().getDisplayMetrics().density;
        return Math.round((float) dp * density);
    }
}
