package com.sharix.sportsmanfriend.dialogs;

import android.app.Dialog;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RadioButton;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.sharix.sportsmanfriend.BaseDialogClass;
import com.sharix.sportsmanfriend.R;

import java.util.ArrayList;
import java.util.List;

public class ChoiceOfSportDialog extends BaseDialogClass
{
    RadioButton selectedRadioButton;

    @NonNull
    @Override
    public Dialog onCreateDialog(@Nullable Bundle savedInstanceState) {
        LayoutInflater inflater = requireActivity().getLayoutInflater();
        view = inflater.inflate(R.layout.dialog_choice_of_sport, null);

        addClickEventToAllViews();

        return super.onCreateDialog(savedInstanceState);
    }

    @Override
    protected Bundle DataToTransfer() {
        Bundle bundle = new Bundle();
        bundle.putString("FromBlock", "SportBlock");
        for (RadioButton RB : findAllRadioButtons((ViewGroup) view)){
            if (RB.isChecked()) {
                selectedRadioButton = RB;
                break;
            }
        }
        String tag = (String) selectedRadioButton.getTag();
        String[] arr = tag.split(",");
        bundle.putInt("Id", Integer.parseInt(arr[0]));
        bundle.putString("Name", arr[1]);
        return bundle;
    }

    private List<RadioButton> findAllRadioButtons(ViewGroup root) {
        List<RadioButton> radioButtons = new ArrayList<>();
        for (int i = 0; i < root.getChildCount(); i++) {
            View child = root.getChildAt(i);
            if (child instanceof RadioButton) {
                radioButtons.add((RadioButton) child);
            } else if (child instanceof ViewGroup) {
                radioButtons.addAll(findAllRadioButtons((ViewGroup) child));
            }
        }
        return radioButtons;
    }

    @Override
    protected void addClickEventToAllViews() {
        super.addClickEventToAllViews();

        List<RadioButton> radioButtons = findAllRadioButtons((ViewGroup) view);
        for (RadioButton element : radioButtons) {
            element.setOnCheckedChangeListener((buttonView, isChecked) -> {
                if (isChecked) {
                    for (RadioButton _element : radioButtons) {
                        if (_element != buttonView) {
                            _element.setChecked(false);
                        }
                    }
                }
            });
        }
    }
}
