package com.sharix.sportsmanfriend.dialogs;

import android.app.Dialog;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.widget.CalendarView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.sharix.sportsmanfriend.BaseDialogClass;
import com.sharix.sportsmanfriend.R;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;

public class DateOfEventDialog extends BaseDialogClass{

    private CalendarView calendarView;
    private Date calendarDate;

    @NonNull
    @Override
    public Dialog onCreateDialog(@Nullable Bundle savedInstanceState) {
        LayoutInflater inflater = requireActivity().getLayoutInflater();
        view = inflater.inflate(R.layout.dialog_date_of_event, null);

        calendarView = view.findViewById(R.id.calendar);

        addClickEventToAllViews();

        return super.onCreateDialog(savedInstanceState);
    }

    @Override
    protected Bundle DataToTransfer() {
        Bundle bundle = new Bundle();
        bundle.putString("FromBlock", "DayBlock");
        SimpleDateFormat dateFormat = new SimpleDateFormat("dd MMMM yyyy", Locale.getDefault());
        if(calendarDate == null)
            calendarDate = new Date(calendarView.getDate());
        String formattedDate = dateFormat.format(calendarDate);
        bundle.putString("DateToText", formattedDate);
        bundle.putString("DateToVariable", calendarDate.toString());
        return bundle;
    }

    @Override
    protected void addClickEventToAllViews() {
        super.addClickEventToAllViews();

        calendarView.setOnDateChangeListener((view, year, month, dayOfMonth) -> {
            Log.d("TAG", String.valueOf(year));
            calendarDate = new Date(year - 1900, month, dayOfMonth);
        });
    }
}
