package com.sharix.sportsmanfriend.dialogs;

import android.app.Dialog;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.google.android.material.slider.RangeSlider;
import com.sharix.sportsmanfriend.BaseDialogClass;
import com.sharix.sportsmanfriend.R;

import java.util.List;

public class MemberLimitDialog extends BaseDialogClass {

    private TextView tv_number_from, tv_number_to;
    private RangeSlider rangeSlider;

    @NonNull
    @Override
    public Dialog onCreateDialog(@Nullable Bundle savedInstanceState) {
        LayoutInflater inflater = requireActivity().getLayoutInflater();
        view = inflater.inflate(R.layout.dialog_member_limit, null);

        tv_number_from = view.findViewById(R.id.tv_number_from);
        tv_number_to = view.findViewById(R.id.tv_number_to);
        rangeSlider = view.findViewById(R.id.rangeSlider);

        configureRangeSlider();
        addClickEventToAllViews();

        return super.onCreateDialog(savedInstanceState);
    }

    @Override
    protected Bundle DataToTransfer() {
        Bundle bundle = new Bundle();
        bundle.putString("FromBlock", "MemberLimitsBlock");
        List<Float> values = rangeSlider.getValues();
        bundle.putInt("LimitFrom", values.get(0).intValue());
        bundle.putInt("LimitTo", values.get(1).intValue());
        return bundle;
    }

    private void configureRangeSlider(){
        rangeSlider.setValues(2f, 50f);
        tv_number_from.setText(String.valueOf(2));
        tv_number_to.setText(String.valueOf(50));
    }

    @Override
    protected void addClickEventToAllViews() {
        super.addClickEventToAllViews();

        rangeSlider.addOnChangeListener((slider, value, fromUser) -> {
            List<Float> values = rangeSlider.getValues();
            tv_number_from.setText(String.valueOf(values.get(0).intValue()));
            tv_number_to.setText(String.valueOf(values.get(1).intValue()));
        });
    }
}
