package com.sharix.sportsmanfriend.view;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.sharix.sportsmanfriend.R;

import java.util.ArrayList;
import java.util.List;

public class LoginActivity extends AppCompatActivity {

    private Button btnNext;
    private TextView goBack;
    private List<EditText> edArray = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);

        btnNext = findViewById(R.id.btnNext);
        goBack = findViewById(R.id.tv_change_email);
        EditText editText1 = findViewById(R.id.ed1);
        EditText editText2 = findViewById(R.id.ed2);
        EditText editText3 = findViewById(R.id.ed3);
        EditText editText4 = findViewById(R.id.ed4);
        edArray.add(editText1);
        edArray.add(editText2);
        edArray.add(editText3);
        edArray.add(editText4);

        AddClickToAllViews();

    }

    private void AddClickToAllViews() {

        btnNext.setOnClickListener(view -> {
            Intent intent = new Intent(LoginActivity.this, MainActivity.class);
            startActivity(intent);
        });

        goBack.setOnClickListener(view -> finish());

        for (int i = 0; i < edArray.size(); i++){
            final int tempIndex = i;
            edArray.get(i).addTextChangedListener(new TextWatcher() {
                int oldLength;
                @Override
                public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                    oldLength = edArray.get(tempIndex).getText().length();
                }

                @Override
                public void onTextChanged(CharSequence s, int start, int before, int count) {

                }

                @Override
                public void afterTextChanged(Editable s) {
                    if (edArray.get(tempIndex).getText().length() < oldLength) {
                        if(tempIndex - 1 != -1){
                            edArray.get(tempIndex - 1).requestFocus();
                        }
                        return;
                    }

                    if(tempIndex + 1 < edArray.size()){
                        edArray.get(tempIndex + 1).requestFocus();
                    }
                }
            });
        }
    }
}