package com.sharix.sportsmanfriend.view.fragments;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.ClipData;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.constraintlayout.widget.ConstraintLayout;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.google.android.material.imageview.ShapeableImageView;
import com.sharix.sportsmanfriend.BaseDialogClass;
import com.sharix.sportsmanfriend.BaseFragmentClass;
import com.sharix.sportsmanfriend.PhotoHelperClass;
import com.sharix.sportsmanfriend.R;
import com.sharix.sportsmanfriend.dialogs.ChoiceOfGenderDialog;
import com.sharix.sportsmanfriend.dialogs.ChoiceOfSportDialog;
import com.sharix.sportsmanfriend.dialogs.DateOfEventDialog;
import com.sharix.sportsmanfriend.dialogs.EndDateOfEventDialog;
import com.sharix.sportsmanfriend.dialogs.MemberLimitDialog;
import com.sharix.sportsmanfriend.dialogs.RecommendedLevelDialog;
import com.sharix.sportsmanfriend.dialogs.SelectLocationDialog;
import com.sharix.sportsmanfriend.dialogs.TimeOfEventDialog;

import java.time.LocalDateTime;
import java.util.Locale;
import java.util.Objects;

public class CreateEventFragment extends BaseFragmentClass implements BaseDialogClass.DialogListener {
    // Элементы на которые будет вызываться диалоговое окно
    private ConstraintLayout locationBlock, sportBlock, memberLimitBlock, dayBlock, timeBlock, endRegistrationBlock,
            levelBlock, genderBlock;
    private ImageButton btnGetImageFromGallery, btnGetImageFromCamera;
    // поля для отображения выбранных значений в диалогах
    private TextView locationBlockText, sportBlockText, memberLimitsBlockText, dayBlockText, timeBlockText,
            endRegistrationBlockText, levelBlockText, genderBlockText;
    private ShapeableImageView LocationBlockImage;
    // данные для бд
    private String description;
    public double latitude, longitude ;
    private LocalDateTime event_start, end_registration;
    private int sport_id, min_participants, max_participants, level_min, level_max;
    // константы
    private final int RESULT_LOAD_IMAGE = 1, CAMERA_REQUEST = 1888;
    private LinearLayout photoContainer;
    private EditText notes;
    private Button saveButton;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View v = inflater.inflate(R.layout.fragment_create_event, container, false);

        locationBlock = v.findViewById(R.id.eventLocationBlock);
        locationBlockText = v.findViewById(R.id.eventLocationBlockText);
        LocationBlockImage = v.findViewById(R.id.shapeableImageView);
        sportBlock = v.findViewById(R.id.sportBlock);
        sportBlockText = v.findViewById(R.id.sportBlockText);
        memberLimitBlock = v.findViewById(R.id.memberLimitsBlock);
        memberLimitsBlockText = v.findViewById(R.id.memberLimitsBlockText);
        dayBlock = v.findViewById(R.id.dayBlock);
        dayBlockText = v.findViewById(R.id.dayBlockText);
        timeBlock = v.findViewById(R.id.timeBlock);
        timeBlockText = v.findViewById(R.id.timeBlockText);
        endRegistrationBlock = v.findViewById(R.id.endRegistrationBlock);
        endRegistrationBlockText = v.findViewById(R.id.endRegistrationBlockText);
        levelBlock = v.findViewById(R.id.levelBlock);
        levelBlockText = v.findViewById(R.id.levelBlockText);
        genderBlock = v.findViewById(R.id.genderBlock);
        genderBlockText = v.findViewById(R.id.genderBlockText);
        btnGetImageFromGallery = v.findViewById(R.id.btn_get_image_from_galary);
        btnGetImageFromCamera = v.findViewById(R.id.btn_get_image_from_camera);
        photoContainer = v.findViewById(R.id.photo_container);
        notes = v.findViewById(R.id.notes);
        saveButton = v.findViewById(R.id.btnSave);

        addClickEventToAllViews();

        return v;
    }

    private void addClickEventToAllViews(){
        sportBlock.setOnClickListener(v -> {
            ChoiceOfSportDialog choiceOfSportDialog = new ChoiceOfSportDialog();
            choiceOfSportDialog.setTargetFragment(CreateEventFragment.this, 0);
            choiceOfSportDialog.show(requireActivity().getSupportFragmentManager(), "choiceOfSportDialog");
        });

        locationBlock.setOnClickListener(v -> {
            SelectLocationDialog selectLocationDialog = new SelectLocationDialog();
            selectLocationDialog.setTargetFragment(CreateEventFragment.this, 0);
            selectLocationDialog.show(requireActivity().getSupportFragmentManager(), "selectLocationDialog");
        });

        memberLimitBlock.setOnClickListener(v -> {
            MemberLimitDialog memberLimitDialog = new MemberLimitDialog();
            memberLimitDialog.setTargetFragment(CreateEventFragment.this, 0);
            memberLimitDialog.show(requireActivity().getSupportFragmentManager(), "memberLimitDialog");

        });

        dayBlock.setOnClickListener(v -> {
            DateOfEventDialog dateOfEventDialog = new DateOfEventDialog();
            dateOfEventDialog.setTargetFragment(CreateEventFragment.this, 0);
            dateOfEventDialog.show(requireActivity().getSupportFragmentManager(), "dateOfEventDialog");
        });

        timeBlock.setOnClickListener(v -> {
            TimeOfEventDialog timeOfEventDialog = new TimeOfEventDialog();
            timeOfEventDialog.setTargetFragment(CreateEventFragment.this, 0);
            timeOfEventDialog.show(requireActivity().getSupportFragmentManager(), "timeOfEventDialog");
        });

        endRegistrationBlock.setOnClickListener(v -> {
            EndDateOfEventDialog dateOfEventDialog = new EndDateOfEventDialog();
            dateOfEventDialog.setTargetFragment(CreateEventFragment.this, 0);
            dateOfEventDialog.show(requireActivity().getSupportFragmentManager(), "dateOfEventDialog");

        });

        levelBlock.setOnClickListener(v -> {
            RecommendedLevelDialog recommendedLevelDialog = new RecommendedLevelDialog();
            recommendedLevelDialog.setTargetFragment(CreateEventFragment.this, 0);
            recommendedLevelDialog.show(requireActivity().getSupportFragmentManager(), "recommendedLevelDialog");
        });

        genderBlock.setOnClickListener(v -> {
            ChoiceOfGenderDialog choiceOfGenderDialog = new ChoiceOfGenderDialog();
            choiceOfGenderDialog.setTargetFragment(CreateEventFragment.this, 0);
            choiceOfGenderDialog.show(requireActivity().getSupportFragmentManager(), "choiceOfGenderDialog");
        });

        btnGetImageFromGallery.setOnClickListener(v -> {
            Intent intent = new Intent();
            intent.setType("image/*");
            intent.putExtra(Intent.EXTRA_ALLOW_MULTIPLE, true);
            intent.setAction(Intent.ACTION_GET_CONTENT);
            intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
            startActivityForResult(Intent.createChooser(intent,"Select Picture"), RESULT_LOAD_IMAGE);
        });

        btnGetImageFromCamera.setOnClickListener(v -> {
            Intent cameraIntent = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
            startActivityForResult(cameraIntent, CAMERA_REQUEST);
        });

        saveButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                FragmentManager fragmentManager = requireActivity().getSupportFragmentManager();
                FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
                CreateEventFragment myFragment = new CreateEventFragment();
                fragmentTransaction.replace(R.id.frameWindow, myFragment);
                fragmentTransaction.commit();
            }
        });
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        if (requestCode == RESULT_LOAD_IMAGE && resultCode == Activity.RESULT_OK) {
            // Получаем URI-адреса выбранных изображений
            ClipData clipData = data.getClipData();
            if (clipData != null) {
                for (int i = 0; i < clipData.getItemCount(); i++) {
                    Uri imageUri = clipData.getItemAt(i).getUri();
                    // Преобразуем URI-адрес в Bitmap
                    Bitmap bitmap = PhotoHelperClass.getBitmapFromUri(imageUri, requireActivity());
                    Bitmap squareBitmap = PhotoHelperClass.cropBitmapToSquare(Objects.requireNonNull(bitmap), requireActivity());
                    addImageToPhotos(squareBitmap);
                }
            } else {
                Uri imageUri = data.getData();
                // Преобразуем URI-адрес в Bitmap
                Bitmap bitmap = PhotoHelperClass.getBitmapFromUri(imageUri, requireActivity());
                Bitmap squareBitmap = PhotoHelperClass.cropBitmapToSquare(Objects.requireNonNull(bitmap), requireActivity());
                addImageToPhotos(squareBitmap);
            }
        }
        if (requestCode == CAMERA_REQUEST && resultCode == Activity.RESULT_OK) {
            Bitmap photo = (Bitmap) data.getExtras().get("data");
            Bitmap squareBitmap = PhotoHelperClass.cropBitmapToSquare(photo, requireActivity());
            addImageToPhotos(squareBitmap);
        }
    }

    private void addImageToPhotos(Bitmap bitmap){
        ImageView imageView = new ImageView(requireActivity());
        imageView.setLayoutParams(new ViewGroup.LayoutParams(PhotoHelperClass.dpToPx(100, requireActivity()), PhotoHelperClass.dpToPx(100, requireActivity())));
        imageView.setPadding(10, 0, 0, 0);
        imageView.setImageBitmap(bitmap);
        photoContainer.addView(imageView);
    }

    @Override
    protected boolean hasSavedState() {
        return false;
    }

    @Override
    protected Bundle getStateToSave() {
        return null;
    }

    @SuppressLint("DefaultLocale")
    @Override
    public void applyInfo(Bundle bundle) {
        switch (bundle.getString("FromBlock")){
            case "SportBlock":
                sportBlockText.setText(bundle.getString("Name"));
                break;
            case "LocationBlock":
                LocationBlockImage.setImageBitmap(BitmapFactory.decodeByteArray(bundle.getByteArray("screenshot"), 0, bundle.getByteArray("screenshot").length));
                locationBlockText.setText(String.format("latitude: %s longitude: %s", bundle.getDouble("latitude"), bundle.getDouble("longitude")));
                latitude = bundle.getDouble("latitude");
                longitude = bundle.getDouble("longitude");
                break;
            case "MemberLimitsBlock":
                memberLimitsBlockText.setText(String.format("%d - %d", bundle.getInt("LimitFrom"), bundle.getInt("LimitTo")));
                break;
            case "DayBlock":
                dayBlockText.setText(bundle.getString("DateToText"));
                break;
            case "TimeBlock":
                timeBlockText.setText(String.format("%s - %s", String.format(Locale.getDefault(), "%02d:%02d",
                        bundle.getInt("HourStart"), bundle.getInt("MinuteStart")), String.format(Locale.getDefault(), "%02d:%02d",
                        bundle.getInt("HourEnd"), bundle.getInt("MinuteEnd"))));
                break;
            case "EndRegistrationBlock":
                endRegistrationBlockText.setText(String.format("%s %s", bundle.getString("DateToText"), String.format(Locale.getDefault(), "%02d:%02d",
                        bundle.getInt("HourEnd"), bundle.getInt("MinuteEnd"))));
                break;
            case "LevelBlock":
                levelBlockText.setText(String.format("%s - %s", bundle.getFloat("LimitFrom"), bundle.getFloat("LimitTo")));
                break;
            case "GenderBlock":
                genderBlockText.setText(bundle.getString("Name"));
                break;
        }
    }
}