package com.sharix.sportsmanfriend.view.fragments;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.LinearLayout;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.sharix.sportsmanfriend.OnBackPressedListener;
import com.sharix.sportsmanfriend.R;

public class EventListFragment extends Fragment implements OnBackPressedListener {

    private LinearLayout btnOpenEventMap, OpenEventCard;
    private ImageButton btnFilters;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_event_list, container, false);

        btnOpenEventMap = view.findViewById(R.id.btnOpenEventMap);
        OpenEventCard = view.findViewById(R.id.event);
        btnFilters = view.findViewById(R.id.btnFilters);

        addClickEventToAllViews();

        return view;
    }

    private void addClickEventToAllViews() {

        btnOpenEventMap.setOnClickListener(v -> {
            onBackPressed();
        });

        OpenEventCard.setOnClickListener(v -> {
            FragmentManager fragmentManager = requireActivity().getSupportFragmentManager();
            FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
            AboutEventFragment myFragment = new AboutEventFragment();
            fragmentTransaction.replace(R.id.frameWindow, myFragment);
            fragmentTransaction.addToBackStack(null);
            fragmentTransaction.commit();
        });

        btnFilters.setOnClickListener(v -> {
            FragmentManager fragmentManager = requireActivity().getSupportFragmentManager();
            FragmentTransaction fragmentTransaction = fragmentManager.beginTransaction();
            EventFiltersFragment myFragment = new EventFiltersFragment();
            fragmentTransaction.replace(R.id.frameWindow, myFragment);
            fragmentTransaction.addToBackStack(null);
            fragmentTransaction.commit();
        });
    }

    @Override
    public void onBackPressed() {
        requireActivity().getSupportFragmentManager().popBackStack();
    }
}